task-latex(7) -- latex task(s) for bake(1)
=============================================

## SYNOPSIS

Latex task(s) for bake(1).

## DESCRIPTION

Compile `.tex` source files to `.pdf` or `.dvi` files. When no options are specified this task searches the `doc/latex` directory relative to the tasks(7) file and compiles all `.tex` files found into `.pdf` files within the `${target}` for the project.

Any option not recognised by this task is passed to pdflatex(1) so that you may set more advanced compilation options.

In addition, this task will change into the directory containing the source `.tex` file so that graphics or any other external files can be resolved relative to the `.tex` file without specifying `\\graphicspath` or other similar macros that may be required to resolve external files.

## REQUIRE

In your tasks(7) file `require` the `latex` task(s) using:

	require 'tasks/latex';

## USAGE

	bake latex [pdf|dvi] [options...] [files...]
	
## COMMANDS

* `pdf`:

	Sets the output format to pdf. This is the default output format used.
	
* `dvi`:

	Sets the output format to dvi.
	
## OPTIONS

* `-d | --dir [directory]`:

	Specifies an alternative directory to search for source `.tex` files. Default is `./doc/latex`.

* `-o | --output [directory]`:

	The output directory when compiling the source `.tex` file(s).
	
## FLAG OPTIONS

* `--debug`:

	Print the commands being executed. If execution of pdflatex(1) fails with a >0 exit code then the contents of the log file are printed to stderr when this option is present.
	
## FILES

Apart from the files generated by pdflatex(1) in the output directory, this task will create an additional file with the stdout and stderr output of calling pdflatex(1). The generated file is placed in the output directory and has the name of the source file (with the .tex file extension removed) concatenated with `.compile.log`. Note that we do not separate the stdout and stderr streams as all pdflatex(1) output is sent to stdout.
	
## DEPENDENCIES

pdflatex(1), find(1)

## BUGS

This task does not support passing commands after the file specification to pdflatex(1). If you need this functionality, execute pdflatex(1) directly.

**task-latex** is written in bash and depends upon `bash` >= 4.2.

## COPYRIGHT

**task-latex** is copyright (c) 2012 muji <http://xpm.io>

## SEE ALSO

bake(1)


[SYNOPSIS]: #SYNOPSIS "SYNOPSIS"
[DESCRIPTION]: #DESCRIPTION "DESCRIPTION"
[REQUIRE]: #REQUIRE "REQUIRE"
[USAGE]: #USAGE "USAGE"
[COMMANDS]: #COMMANDS "COMMANDS"
[OPTIONS]: #OPTIONS "OPTIONS"
[FLAG OPTIONS]: #FLAG-OPTIONS "FLAG OPTIONS"
[FILES]: #FILES "FILES"
[DEPENDENCIES]: #DEPENDENCIES "DEPENDENCIES"
[BUGS]: #BUGS "BUGS"
[COPYRIGHT]: #COPYRIGHT "COPYRIGHT"
[SEE ALSO]: #SEE-ALSO "SEE ALSO"


[strike(1)]: strike.1.html
[boilerplate(3)]: boilerplate.3.html
[require(3)]: require.3.html
[method(3)]: method.3.html
[http(3)]: http.3.html
[bake(1)]: bake.1.html
[rest(1)]: rest.1.html
[bash(1)]: http://man.cx/bash(1)
[curl(1)]: http://man.cx/curl(1)
[echo(1)]: http://man.cx/echo(1)
[find(1)]: http://man.cx/find(1)
[tee(1)]: http://man.cx/tee(1)
[sed(1)]: http://man.cx/sed(1)
[printf(1)]: http://man.cx/printf(1)
[source(1)]: http://man.cx/source(1)
[dirname(1)]: http://man.cx/dirname(1)
[basename(1)]: http://man.cx/basename(1)
[tar(1)]: http://man.cx/tar(1)
[zip(1)]: http://man.cx/zip(1)
[unzip(1)]: http://man.cx/unzip(1)
[compress(1)]: http://man.cx/compress(1)
[gzip(1)]: http://man.cx/gzip(1)
[gunzip(1)]: http://man.cx/gunzip(1)
[pdflatex(1)]: http://man.cx/pdflatex(1)
[openssl(1)]: http://man.cx/openssl(1)
[scp(1)]: http://man.cx/scp(1)
[ssh(1)]: http://man.cx/ssh(1)
[rsync(1)]: http://man.cx/rsync(1)
[autoreconf(1)]: http://man.cx/autoreconf(1)
[checkbashisms(1)]: http://man.cx/checkbashisms
[growlnotify(1)]: http://scottlab.ucsc.edu/Library/init/zsh/man/html/growlnotify.html
[sendmail(1)]: http://man.cx/sendmail(1)
[uuencode(1)]: http://man.cx/uuencode(1)
[epxand(1)]: http://man.cx/expand(1)
[unepxand(1)]: http://man.cx/unexpand(1)
[git(1)]: http://git-scm.com/
[ronn(1)]: https://github.com/rtomayko/ronn
[github(7)]: http://github.com/
[json-sh(1)]: https://github.com/dominictarr/JSON.sh
[npm(1)]: http://npmjs.org
[ruby(3)]: http://www.ruby-lang.org/
[rake(1)]: http://rake.rubyforge.org/
[semver(7)]: http://semver.org/
[ant(1)]: http://ant.apache.org/
[mvn(1)]: http://maven.apache.org/
[make(1)]: http://www.gnu.org/software/make/
[jsonlint(1)]: https://github.com/zaach/jsonlint
[jsoncheck(1)]: http://json.org/JSON_checker/
[ere(7)]: http://pubs.opengroup.org/onlinepubs/9699919799/basedefs/V1_chap09.html
[couchdb(7)]: http://couchdb.apache.org/
[url(7)]: http://www.ietf.org/rfc/rfc1738.txt
[array-file(3)]: array-file.3.html
[array(3)]: array.3.html
[console(1)]: console.1.html
[console(3)]: console.3.html
[delegate(3)]: delegate.3.html
[executable(3)]: executable.3.html
[git(3)]: git.3.html
[globals(3)]: globals.3.html
[help(3)]: help.3.html
[json(3)]: json.3.html
[manual(1)]: manual.1.html
[prompt(1)]: prompt.1.html
[prompt(3)]: prompt.3.html
[semver(3)]: semver.3.html
[sprintf(3)]: sprintf.3.html
[strike-credits(7)]: strike-credits.7.html
[strike-tree(7)]: strike-tree.7.html
[strike(7)]: strike.7.html
[task-ant(7)]: task-ant.7.html
[task-archive(7)]: task-archive.7.html
[task-clean(7)]: task-clean.7.html
[task-compress(7)]: task-compress.7.html
[task-deploy-json(7)]: task-deploy-json.7.html
[task-deploy(7)]: task-deploy.7.html
[task-devel(7)]: task-devel.7.html
[task-doc(7)]: task-doc.7.html
[task-expand(7)]: task-expand.7.html
[task-latex(7)]: task-latex.7.html
[task-ls(7)]: task-ls.7.html
[task-make(7)]: task-make.7.html
[task-module(7)]: task-module.7.html
[task-mvn(7)]: task-mvn.7.html
[task-project(7)]: task-project.7.html
[task-rake(7)]: task-rake.7.html
[task-semver(7)]: task-semver.7.html
[task-test(7)]: task-test.7.html
[task-todo(7)]: task-todo.7.html
[version(3)]: version.3.html
