# print version information
version.print(){
  if [ -n "${version}" ]; then
    console print "%s version %s" \
      "$process_name" "$version";
  fi
}

# display version information and exit with code 0
# if version information is available or >0 if no
# version information is available
version.show() {
  local versionfile="${process_dirs[version]}";
  if [ ! -f "$versionfile" ] || [ ! -r "$versionfile" ]; then
    console quit 1 "no version information available";
  fi
  local version=$( cat "$versionfile" );
  console print "%s version %s" "$process_name" "$version";
  console success;
}

# parse options looking for a --version
# option and display version information when possible
version.parse() {
  # parse options in a non-destructive manner
  local opt;
  for((i=1;i < $#+1;i++))
    do
      eval "opt=\"\${$i}\"";
      case $opt in
        --version )
          version.show;
          ;;
      esac
  done
}
