crypto.initialize() {
  executable.validate openssl;  
}

crypto.rsa.generate() {
  local passphrase="${1:-true}";
  local bits="${2:-2048}";
  local out="${3:-}";
  local pub="${4:-}";
  local logfile="${5:-/dev/null}";
  if [ -n "$out" ]; then
    local opts=( genrsa );
    if $passphrase; then
      opts+=( "-des3" );
    fi
    opts+=( -out "${out}" );
    opts+=( $bits );
    #echo "${executables[openssl]} ${opts[@]}";
    "${executables[openssl]}" "${opts[@]}" 1> "$logfile" 2>&1;
    if [ $? -eq 0 ] && [ -n "$pub" ]; then
      crypto.rsa.public.generate "$out" "$pub";
      return $?;
    fi
  fi
  return 1;
}

crypto.rsa.public.generate() {
  local pem="${1:-}";
  local pub="${2:-}";
  local logfile="${3:-/dev/null}";
  if [ -n "$pem" ] && [ -n "$pub" ]; then
    local opts=( "rsa" "-in" "${pem}" "-pubout" "-out" "$pub" );
    "${executables[openssl]}" "${opts[@]}" 1> "$logfile" 2>&1;
    return $?;
  fi
  return 1;
}

crypto.enc.aes256cbc() {
  local infile="${1:-}";
  local outfile="${2:-}";
  local password="${3:-}";
  if [ -n "$infile" ] && [ -n "$outfile" ]; then
    local opts=( "aes-256-cbc" "-salt" );
    if [ -n "$infile" ] && [ "${infile}" != "-" ]; then
      opts+=( "-in" "${infile}" );
    fi    
    if [ -n "$outfile" ] && [ "${outfile}" != "-" ]; then
      opts+=( "-out" "${outfile}" );
    fi
    if [ -n "$password" ]; then
      opts+=( "-pass" "pass:${password}" );
    fi
    "${executables[openssl]}" "${opts[@]}";
    return $?;
  fi
  return 1;
}

crypto.dec.aes256cbc() {
  local infile="${1:-}";
  local outfile="${2:-}";
  local password="${3:-}";
  if [ -n "$infile" ] && [ -n "$outfile" ]; then
    # openssl des3 -d -in encrypted.txt -out normal.txt
    local opts=( "aes-256-cbc" "-d" "-in" "${infile}" );
    if [ -n "$outfile" ] && [ "${outfile}" != "-" ]; then
      opts+=( "-out" "${outfile}" );
    fi
    if [ -n "$password" ]; then
      opts+=( "-pass" "pass:${password}" );
    fi
    #echo "$FUNCNAME: ${opts[@]}";
    "${executables[openssl]}" "${opts[@]}";
    return $?;
  fi
  return 1;
}
